## aspectc++ 2.3

=== AspectC++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************

# AspectC++ supports alternative frontends: Puma or Clang
# It can be configured the 'make FRONTEND=...'. Default is Clang.
export FRONTEND ?= Clang

# PUMA root
PUMA    ?= ../Puma

# LLVM config command
LLVMCONF ?= llvm-config

# libxml2 config command
XML2CONF ?= xml2-config

# default target
TARGET  ?= linux-release

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

# check whether we compile for Windows: TARGET-Variable starts with 'win'
ifneq ($(filter win%,$(TARGET)),)
	WIN := yes
	EXT := .exe
endif

# libxml2 settings
LIBXML2_INC := `$(XML2CONF) --cflags` 
LIBXML2_LIB := `$(XML2CONF) --libs` 

# Check Clang version and define all necessary symbols (LLVM_*)
ifneq ($(MAKECMDGOALS),clean)
  ifeq ($(FRONTEND),Clang)
    include config/clang.mk
  endif
endif

# linker settings
ifneq ($(_TARGET),macosx_x86_64)
ifeq ($(SHARED),)
  LDFLAGS += -static
endif
ifeq ($(FRONTEND),Puma)
	LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -lPuma 
ifneq ($(SHARED),)
	LDFLAGS += -Wl,-Bdynamic
endif
else # FRONTEND is Clang
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lMiniPuma 
ifneq ($(SHARED),)
	LDFLAGS += #-Wl,-Bdynamic
endif
endif
else
ifeq ($(FRONTEND),Puma)
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lPuma
else # FRONTEND is Clang
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lMiniPuma
endif
endif

LDFLAGS += $(LIBXML2_LIB)
ifneq ($(FRONTEND),Puma)
ifneq ($(_TARGET),macosx_x86_64)
  LDFLAGS += -lclangRewriteFrontend -lclangRewrite -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangSema -lclangAnalysis -lclangEdit -lclangAST -lclangLex -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
  # On the ARMEL platform we also need -latomic. This is a workaround for a gcc bug.
  LDFLAGS += -Wl,--as-needed -latomic -Wl,--no-as-needed
  # ... until here
#  LDFLAGS += `$(LLVMCONF) --libs`
  LDFLAGS += $(patsubst %,-Xlinker --wrap=%,$(LLVM_SYMBOLS))
else
# Mac OS X is special, we patch the clang libraries below.
  LDFLAGS += libclangSema.o -lclangRewriteFrontend -lclangRewrite -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangAnalysis -lclangEdit -lclangAST -lclangLex -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
endif
LDFLAGS += `$(LLVMCONF) --ldflags`
# - Additional libraries ("--libs") needed
# - Starting with 4.0 "--system-libs" returns nothing if the debian clang package is used. "--link-static" forces
#   "--system-libs" to return the system libs in all cases
LDFLAGS += $(shell $(LLVMCONF) --libs --system-libs --link-static)
# workaround for strange MacOS config from clang                                                                                    
ifeq ($(_TARGET),macosx_x86_64)
LDFLAGS := $(filter-out -llibxml2.tbd, $(LDFLAGS))
endif
endif

# compiler settings
ifeq ($(WIN),yes)
	RES := windres
	RCFILES := win-ac++.rc
endif

CPPFLAGS += -I$(PUMA)/extern -I$(PUMA)/include $(LIBXML2_INC)
ifeq ($(FRONTEND),Puma)
  CPPFLAGS += -DFRONTEND_PUMA
else
  FILTEROUT :=
ifeq ($(RELEASE),debug)
  # filter-out "-DNDEBUG" added by LLVMCONF, if LLVM is in built in release-mode
  FILTEROUT := -DNDEBUG
endif
  LLVM_CPPFLAGS := $(shell $(LLVMCONF) --cppflags)
  ifeq ($(WIN),yes)
    # llvm-config on Windows generates path name with '\' that mingw g++ can't handle properly
    LLVM_CPPFLAGS := $(subst \,/,$(LLVM_CPPFLAGS))
  endif
  CPPFLAGS += $(filter-out $(FILTEROUT),$(LLVM_CPPFLAGS))
  CPPFLAGS += -DFRONTEND_CLANG
  CXXFLAGS += -fno-rtti -Wno-strict-aliasing # hide annoying warning in Clang header
  CXXFLAGS += -std=gnu++14 # Clang >= 11 uses C++14 features; "c++14" does not work -> WIN32 not defined on Windows!
endif

# profiling
ifneq ($(GPROF),)
	LDFLAGS := $(LDFLAGS) -lc_p -lm_p 
	CXXFLAGS += -pg
endif

ifneq ($(PROFILING),)
	CPPFLAGS += -DPROFILING
endif

# use libacmodel
LDFLAGS  += -LACModel/lib/$(TARGET) -lacmodel 


# ******************************
# *       S O U R C E S        *
# ******************************

BINDIR := bin/$(TARGET)

#programm to compile
PROG := $(BINDIR)/ac++$(EXT)

# sources; front-end specific files for the wrong frontend are filtered out
CCSOURCES := $(wildcard *.cc)
ifeq ($(FRONTEND),Puma)
CCSOURCES := $(filter-out Clang%.cc, $(CCSOURCES))
else
CCSOURCES := $(filter-out Puma%.cc, $(CCSOURCES))
endif

OBJECTDIR := ObjFiles/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:.cc=.o) $(RCFILES:.rc=.o))

DEPDIR := DepFiles/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:.cc=.d))

CONFIGDIR := config

DIRS := $(OBJECTDIR) $(DEPDIR) $(BINDIR)

# ******************************
# *  E X A M P L E  / T E S T  *
# ******************************

# tool selection
export AC := $(shell pwd)/$(PROG)
MAKE ?= make

# ac++ settings for tests
ACFLAGS := -k -v 9

ACEXAMPLES = coverage helloworld modules profiling singleton threads


.PHONY: $(ACEXAMPLES) 


# ******************************
# *      T A R G E T S         *
# ******************************

all: libacmodel showtarget $(PROG)
#.NOTPARALLEL: all

strip: $(PROG)
	@$(STRIP) $<

showtarget:
	@echo "---"
	@echo "Making AspectC++ for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"


clean:  testclean exampleclean
	@echo Making it clean.
	@$(MAKE) -C ACModel clean
	@rm -rf  core core.* *~ $(PROG) $(OBJECTDIR) $(DEPDIR) $(ERROR_FILE)

cleanall:	doxygen-clean clean

test: $(PROG)$(EXT) testall

example: $(PROG)$(EXT) $(addsuffix .example_make, $(ACEXAMPLES))

examplerun: example $(addsuffix .example_run, $(ACEXAMPLES))

exampleclean:
	@rm -rf examples/*-out
	@rm -rf examples/*.acp

doxygen:
	@echo "Making AspectC++ documentation with doxygen"
	@doxygen doc/doxygen.conf && echo "=> see doc/doxygen/html/index.html"

doxygen-clean:
	@rm -rf doc/doxygen

.PHONY: all test clean cleanall example examplerun exampleclean \
        showtarget doxygen doxygen-clean libacmodel

# ******************************
# *       R U L E S            *
# ******************************

$(DIRS) :
	@mkdir -p $@

libacmodel :
	@$(MAKE) -C ACModel

$(PROG): $(OBJECTS) | libacmodel
# For clang on macosx_x86_64 we create relinked objects with the patched symbols.
ifneq ($(FRONTEND),Puma)
ifeq ($(_TARGET),macosx_x86_64)
	@echo "Creating patched clang libraries ..."
	@$(LD) -r `$(LLVMCONF) --libdir`/libclangSema.a -o libclangSema.o -all_load \
          $(foreach SYM, $(LLVM_SYMBOLS_SEMA), -alias $(SYM) ___real$(SYM) -unexported_symbol $(SYM))
endif
endif
	@echo "Linking $@."
	@mkdir -p $(BINDIR)
	@$(CXX) -o $@ $(CXXFLAGS) $^ $(LDFLAGS)


$(OBJECTDIR)/%.o : %.cc
	@echo Making dependency file $(DEPDIR)/$(<:%.cc=%.d).
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM -MP -MT $(OBJECTDIR)/$(<:%.cc=%.o) -MT $(DEPDIR)/$(<:%.cc=%.d) $< > $(DEPDIR)/$(<:%.cc=%.d)
	@echo Making object file $@.
	@mkdir -p $(OBJECTDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

# -Wold-style-cast to find classic C casts "a = (A*)b;"

ifeq ($(WIN),yes)
$(OBJECTDIR)/%.o : %.rc
	@echo Compiling Windows resource file
	@mkdir -p $(OBJECTDIR)
	@$(RES) $(filter -D%,$(CPPFLAGS)) $< $@

endif

test%: 
	$(MAKE) -C tests -s  $*

%.example_make: %
	cd examples/$< ; \
	$(AC) $(ACFLAGS) -I. -p . -d ../$<-out \
	-r ../$<.acp ; \
	cp Makefile ../$<-out/Makefile; \
	cd ../$<-out; g++ -o $< *.cc -lpthread

%.example_run:	%.example_make
	@echo ""
	@echo ---- Running $* ----
	@cd examples/$*-out; `find . -type f -perm -700`

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

=== AspectC++/doc/Makefile ===
LYXFILES := ac-compilerman.lyx ac-languageref.lyx
DIRS := CompilerManual LanguageReference
PDFFILES := $(patsubst %.lyx,gen/%.pdf,$(LYXFILES))
XHTMLFILES := $(patsubst %.lyx,gen/%.xhtml,$(LYXFILES))

VPATH = CompilerManual:LanguageReference

all: $(PDFFILES) $(XHTMLFILES)

gen/%.pdf: %.lyx
	@echo Exporting $@
	@lyx -E pdf2 $@ $< > gen/logpdf.txt

gen/%.xhtml: %.lyx
	@echo Exporting $@
	@lyx -E xhtml $@ $< > gen/logxhtml.txt
	@echo Transforming export file
	@mv $@ $@.trans
	@xsltproc gen/fixhtml.xsl $@.trans > $@
	@rm $@.trans
	@echo Renaming PNGs
	@for f in gen/*_doc_*.png; do mv $$f gen/$${f#*_doc_}; done

clean:
	@rm -rf $(PDFFILES) $(XHTMLFILES) gen/log*.txt gen/*~ $(patsubst %, gen/%_*.png, $(DIRS))

=== AspectC++/tests/Makefile ===
ifeq ($(REGRESSIONTEST),1)
MAKELEVEL := 1
endif

ifeq ($(MAKELEVEL),0)
$(error Sorry, this makefile is not intended to be \
used directly. Please use the makefile in the toplevel \
directory of the AspectC++ source tree instead)
endif

SHELL=/bin/bash
DIFF=diff --strip-trailing-cr

ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
          Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
          ArrayMangling MatchExpr ConsDesAdvice NestedClassFuncAdvice \
          MacroCall CallAdvice CallOnRef TemplateExtCall Bug190 Bug191 Bug192 \
	  Order NonInlineIntros JPType PragmaOnce Bug207 \
	  AbstractDerivedAspect PragmaOnceObserver ThatConst PrivateResult \
          VoidArg ArrayWrapper Bug216 Bug228 ExecAdviceRecursive ExternC \
	  ThatContext IntroIncludes Bug234 Bug234-2 Bug235 Bug239 \
	  ExecAdviceNewDelete ExecAdviceFriend CallPostfixOp STLString \
	  CFlowCycle Bug368 Bug179 RightlessCalls Bug477 \
	  IntroInBase Bug267 Bug268 Bug271 MatchVirtual \
	  PctInClass IntroInAll Instantiation Slice NonInlineSliceInclude \
	  Empty Bug316 Derived Base Bug323 GlobalIds AnonymousStuff \
	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 Bug209 \
          MatchStatic Bug512 SliceJPAPI JPTL NamedPointcuts AspectPrivileges \
	  RepoInvalid RepoVersion Bug321 Bug484 Bug524 DisjointIds AspectOf \
	  MemberPointCut MatchScopeWithin \
	  Bug549 Bug552 Bug554 DefaultArgs Bug561 Bug564 Bug566 Bug570 \
	  Bug571-1 Bug571-2 Bug571-3 Bug575 Bug577 Bug427 AttribAligned \
          VirtualPointcuts Bug580 MacroExpansion Bug768 Bug769 Bug770 Bug772 \
          Bug781 Bug784

ifeq ($(FRONTEND),Clang)
ACTESTS += DataFlowAnalysis
ACTESTS += CallBuiltinOperator MemberPointCut2
ACTESTS += SimpleGetAdvice SimpleSetAdvice CompoundGetSetAdvice FunctionEntity \
           SimpleRefAdvice SimpleAliasAccessMember SimpleGetSetFuncPtr \
           ArrayAccessAdvice MatchScope GetBaseDerived \
           Bug-Typenames DefaultArgs2 CallViaADN Bug574 GetConditional Bug576 \
           Bug567 Bug568 Bug548 Bug589 Bug594 Bug598 CallRef Float128Basic \
           EntityInfo VolatileResult
ACTESTS += Attribute_basic Attribute_inMacro Attribute_removeAttrs
		   #Attribute_pointcuts Attribute_params Attribute_paramEvaluation \
		   #Attribute_paramsIntrospection Attribute_stringParam
                   #TypePrinting_FunctionPointers <-- waiting for clang improvement
endif

# disabled: UnsizedArray
# to be removed: NonInlineIntroInclude
# (uses deprecated introduction syntax massively)

ACMSGTESTS := RepoInvalid RepoVersion Bug570

ACNORUN := $(filter $(ACMSGTESTS), $(ACTESTS))

ACRUN   := $(filter-out $(ACNORUN), $(ACTESTS))

STDOUT_FILE := stdout.txt
STDERR_FILE := stderr.txt
ERROR_FILE :=  error.txt

# ***** The following is only used for the Akut testsystem (REGRESSIONTEST == 1) *****
# ====================================================================================
ifeq ($(REGRESSIONTEST),1)

define do_test_start
    @COUNT=0;PASS=0;FAIL=0;
endef

define do_test_weave
	COUNT=$$(($$COUNT+1)); \
	echo ---START TEST $$COUNT: $1: is expected to PASS; \
	unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(1)/feature.out; \
	exec 2> $(1)/feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cp $(1)/feature.err $(1)/feature.out; \
	rm $(1)/feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $(1) diff-only; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo ---END TEST $$COUNT: $1: PASS \(was expected to pass and did pass\); \
		PASS=$$(($$PASS+1)); \
	else \
		cat $(STDOUT_FILE) ;\
		cat $(STDERR_FILE) ;\
		FAIL=$$(($$FAIL+1)); \
		echo ---END TEST $$COUNT: $1: FAIL \(was expected to pass, but failed\); \
	fi;
endef

define do_test_run
	COUNT=$$(($$COUNT+1)); \
	echo ---START TEST $$COUNT: $1: is expected to PASS; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $(1) diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo ---END TEST $$COUNT: $1: PASS \(was expected to pass and did pass\); \
		PASS=$$(($$PASS+1)); \
	else \
		cat $(STDOUT_FILE) ;\
		cat $(STDERR_FILE) ;\
		FAIL=$$(($$FAIL+1)); \
		echo ---END TEST $$COUNT: $1: FAIL \(was expected to pass, but failed\); \
	fi;
endef

define do_test_end
	echo -n "---EXECUTIVE SUMMARY: " ;\
	if [ $$FAIL -eq $$COUNT ]; then\
		echo FAIL \(all tests failed\) ;\
	elif [ $$FAIL -gt 0 ]; then \
		echo PARTLY \($$(( $$PASS * 100 / $$COUNT ))% tests passed as expected\); \
	else \
		echo PASS \(all tests passed\) ;\
	fi ;\
	echo ---START SUMMARY; \
	echo $$COUNT tests in this testcase; \
	echo $$PASS tests passed as expected; \
	echo $$FAIL tests did not pass as expected; \
	echo $$FAIL expected to pass but failed; \
	echo 0 expected to fail but passed; \
	echo ---END SUMMARY
endef

regression_test:
	$(call do_test_start) \
	$(foreach T, $(ACRUN), $(call do_test_run, $(T))) \
	$(foreach T, $(ACNORUN), $(call do_test_weave, $(T))) \
	$(call do_test_end)

endif

# ================================================================================
# ***** The above is only used for the Akut testsystem (REGRESSIONTEST == 1) *****


all: $(addsuffix .make, $(ACRUN)) $(addsuffix .weave, $(ACNORUN))
	@if [ -f $(ERROR_FILE) ];then \
		echo -e "\n\n"; \
		echo "+---------+"; \
		echo "|ERRORS:  |"; \
		echo "+---------+"; \
		cat $(ERROR_FILE); \
		rm -f $(STDOUT_FILE) $(STDERR_FILE) $(ERROR_FILE); \
		exit 1; \
	 else \
		echo -e "\n\n"; \
	 	echo "All tests OK"; \
	 	rm -f $(STDOUT_FILE) $(STDERR_FILE); \
	 fi;\

ref:  $(addsuffix .ref, $(ACTESTS))

refclean:
	rm */feature.ref

run: $(addsuffix .run, $(ACRUN))

clean: $(addsuffix .clean, $(ACTESTS))


%.weave: %
	@unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $</feature.out; \
	exec 2> $</feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cp $</feature.err $</feature.out; \
	rm $</feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $< diff-only; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
		ERR_FLAG=D; \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;


%.make: %
	@exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $< diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;




%.ref: %
	$(MAKE) -s EXT="$(EXT)" -C $< ref; 

%.run:	%
	@echo Making and running test '$<'
	cd $< && $(MAKE) run

%.clean: %
	cd $< && $(MAKE) clean

.PHONY: all clean run ref

=== Puma/tools/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

SUBDIRS := $(shell find $(shell pwd) -maxdepth 1 -mindepth 1 -type d)
SUBDIRS := $(filter-out %/.svn %/CVS %/scripts, $(SUBDIRS))
SUBDIRS := $(SUBDIRS)

#-------------------------------------------------
# rules
#-------------------------------------------------

all: $(SUBDIRS)
clean: $(SUBDIRS)

$(SUBDIRS):
	@$(MAKE) -C $@ $(MAKECMDGOALS)

.PHONY: all clean $(SUBDIRS)

=== Ag++/tests/src/Makefile ===

ACXX := ../../../AspectC++/bin/linux-release/ag++ 
OBJ_DIR := obj

SRC := $(wildcard *.cc)
OBJ := $(SRC:%.cc=$(OBJ_DIR)/%.o)
AH := $(wildcard *.ah)

PROG := test

all: $(PROG)


clean:
	rm -rf *.acc $(OBJ_DIR) $(PROG) puma.config

$(PROG): $(OBJ)
	$(ACXX) -v 2 -o $@ $+

$(OBJ_DIR)/%.o:%.cc $(AH)
	@mkdir -p $(OBJ_DIR)
	$(ACXX) -v 2 -o $@ -c $<

=== AspectC++/examples/threads/Makefile ===
LDFLAGS=-lpthread
include ../Makefile.generic

=== AspectC++/tests/SimpleGetAdvice/Makefile ===
ACFLAGS ?= --builtin_operators --data_joinpoints
include ../Makefile.generic

=== Puma/examples/macronames/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

PROG     := macronames

ROOT     ?= $(shell pwd)/../..
TARGET   ?= linux-release

INCDIR   := $(ROOT)/include
EXTDIR   := $(ROOT)/extern
LIBDIR   := $(ROOT)/lib/$(TARGET)
OBJDIR   := obj
DEPDIR   := dep

SOURCES  := $(wildcard *.cc) 
OBJECTS  := $(addprefix $(OBJDIR)/,$(SOURCES:.cc=.o))
DEPS     := $(addprefix $(DEPDIR)/,$(SOURCES:.cc=.d))

include $(ROOT)/vars.mk

CPPFLAGS := $(CPPFLAGS) -I$(INCDIR) -I$(EXTDIR)
#-L$(LIBDIR)

#-------------------------------------------------
# rules
#-------------------------------------------------

all: showinfo $(PROG)

showinfo:
	@echo 
	@echo "---"
	@echo "Compiling $(PROG) for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"
	@echo 

$(PROG): $(OBJECTS)
	@echo "Linking $@..."
	@export LD_LIBRARY_PATH=$(LIBDIR); \
	$(CXX) -o $@ $^ $(CXXFLAGS) -L$(LIBDIR) -Wl,-Bstatic -lPuma -Wl,-Bdynamic $(CPPFLAGS) 
#	$(CXX) -o $@ $^ $(CXXFLAGS) -L$(LIBDIR) -Wl,-Bdynamic -lPuma -Wl,-Bdynamic $(CPPFLAGS) 

clean:
	@echo "Making $(PROG) clean..."
	@rm -f $(PROG)
	@rm -rf $(DEPDIR) $(OBJDIR)

#-------------------------------------------------
# targets
#-------------------------------------------------

$(OBJDIR)/%.o : %.cc
	@echo "Compiling $(filter %.cc,$^)..."
	@mkdir -p $(OBJDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -g -o $@ $(filter %.cc,$^)

$(DEPDIR)/%.d : %.cc
	@echo "Generating dependencies for $(filter %.cc,$^)..."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM $(filter %.cc,$^) | \
	sed -e "s/$*\.o/$(OBJDIR)\/& $(DEPDIR)\/$*.d/g" > $@

.PHONY: clean

#-------------------------------------------------
# includes
#-------------------------------------------------

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

=== Puma/tests/bug259/Makefile ===
include ../Makefile.generic

=== Puma/tools/lemon/Makefile ===
all: lemon

lemon: lemon.c

clean:
	rm -f lemon *~

=== debian/changelog ===
aspectc++ (1:2.3-4) unstable; urgency=medium

  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 28 Feb 2021 09:49:38 -0500

aspectc++ (1:2.3-3) experimental; urgency=medium

  * Re-enable the float128 patch

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 21 Feb 2021 14:34:04 -0500

aspectc++ (1:2.3-2) experimental; urgency=medium

  * Add patch from upstream that fixes 32bit segfault
  * Disable clang-gcc14-workaround and float128 patches

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 21 Feb 2021 08:32:46 -0500

aspectc++ (1:2.3-1) unstable; urgency=medium

  * New upstream version 2.3
    - only cleanups and important Clang 11 related fixes compared to
      previous snapshot
  * drop pkgconfig.patch, merged upstream

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 17 Feb 2021 20:10:30 -0500

=== debian/control ===
Source: aspectc++
Section: devel
Priority: optional
Maintainer: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper (>= 10), pkg-config, libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-11-dev, libclang-11-dev
Build-Depends-Indep: doxygen, graphviz, gsfonts
Standards-Version: 4.4.1
Homepage: http://www.aspectc.org
Vcs-Git: https://salsa.debian.org/debian/aspectc
Vcs-Browser: https://salsa.debian.org/debian/aspectc

Package: aspectc++
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, g++
Description: aspect-oriented programming extension for C++
 AspectC++ supports Aspect-Oriented Programming with C++, by providing:
 .
  - an aspect language extension to C++.
  - an aspect weaver that does source-to-source translation.
 .
 AspectC++ provides for C++ similar features like its best known
 cousin, AspectJ, provides for Java.

Package: libpuma-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Suggests: libpuma-doc
Description: C/C++/AspectC++ Scanner and Parsers
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to facilitate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships a static copy of libPuma only.

Package: libpuma-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: C/C++/AspectC++ Scanner and Parsers
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to facilitate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships doxygen generated documentation for Puma.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# disable parallelism inside this makefile (but not submakes)
.NOTPARALLEL:

# Support multiple makes at once
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS := 1
# on i386 and amd64, we query the system unless overriden by DEB_BUILD_OPTIONS
ifeq      ($(DEB_HOST_ARCH),i386)
NUMJOBS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
else ifeq ($(DEB_HOST_ARCH),amd64)
NUMJOBS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
endif
endif

# workaround for bug #701244 - aspectc++ supports __int128 by default
# only when woven on 64bits, which the upstream provided sources don't.
AC_OPTFLAGS = --gnu-int128
export AC_OPTFLAGS

# we seem to have locking issues on kFreeBSD. force single threaded
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
NUMJOBS := 1
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS := -O0 -g
else
	CFLAGS := -O2 -g
endif

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifneq  (,$(filter $(DEB_BUILD_ARCH),armel armhf))
# fatal: Caught standard exception: deque::_M_new_elements_at_back
	CFLAGS := -O1 -g
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
	CFLAGS += -fPIC
endif

export CFLAGS
PUMA_CONFIG=$(CURDIR)/puma.config

test-builds: build-arch-stamp
	Ag++/bin/linux-release/ag++ --gen_config
	echo '-D "__cplusplus=199711L"' >> $(PUMA_CONFIG)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	-$(MAKE) -C AspectC++ PUMA_CONFIG=$(PUMA_CONFIG) FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-11 SHARED=1 AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" REGRESSIONTEST=1 examples test
	PATH=$(CURDIR)/AspectC++/bin/linux-release:$(PATH) \
	$(MAKE) -C Ag++/ SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test

endif

build: build-arch build-indep

build-arch: build-arch-stamp test-builds
build-arch-stamp:
	dh_testdir
	$(MAKE) -C Puma/ MINI=1        -j$(NUMJOBS) all
	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-11
	$(MAKE) -C Ag++/      SHARED=1 -j$(NUMJOBS) all
	# ok, now we have both an ac++ binary and ag++ binary now let's
	# weave Puma again in the copy
	$(MAKE) -C Puma clean
	$(MAKE) -C Puma all AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" -j$(NUMJOBS) EXTENSIONS="acppext gnuext winext"
	# build manpages:
	docbook-to-man debian/ac++.1.sgml > ac++.1
	docbook-to-man debian/ag++.1.sgml > ag++.1
	# mark timestamp
	touch $@

build-indep: build-indep-stamp
build-indep-stamp:
	dh_testdir
	$(MAKE) -C Puma doc
	touch $@

clean:
	dh_testdir
	dh_testroot
	dh_clean build-*stamp binary-*stamp puma.config
	# cleaning up source directories:
	$(MAKE) -s -C Puma cleanall
	# The clang frontend adds additional tests that need cleaning
	# so far, no tests are excluded by using the Clang frontend
	$(MAKE) -s -C AspectC++ cleanall FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-11
	$(MAKE) -s -C Ag++ clean
	# remove leftovers from Upstream Makefiles
	rm -rf Puma/include
	rm -rf AspectC++/tests/RepoVersion/repo.use
	rm -rf Ag++/DepFiles Ag++/ObjFiles Ag++/bin Ag++/tests/test_11.config
	rm -rf AspectC++/DepFiles AspectC++/ObjFiles AspectC++/bin
	rm -rf AspectC++/tests/*/feature.out
	rm -rf AspectC++/tests/RepoVersion/feature.fil
	# remove generated manpages:
	rm -f ac++.1 ag++.1
	rm -rf AspectC++/bin
	rm -rf Puma.copy/
	# remove autopkgtest cruft
	rm -rf Ag++/tests/src/obj
	rm -rf Ag++/tests/src/test
	# standard cleaning:
	dh_clean

# Build architecture-independent files here.
binary-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep
	dh_installchangelogs
	dh_installdocs -p libpuma-doc Puma/doc/RefMan/html
	dh_installexamples -p libpuma-doc Puma/examples/*
	dh_compress -X.cc -X.map
	dh_fixperms
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	dh_installchangelogs
	dh_installdocs
	dh_install -Xlicence_1_0.txt
	dh_installexamples -p aspectc++ AspectC++/examples/*
	find debian/aspectc++ -name Makefile -exec rm -v {} +
	find debian/libpuma-doc -name Makefile -exec rm -v {} +
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build build-indep build-arch clean binary-indep binary-arch binary

## aspectc++ 2.3+git20221129

=== AspectC++/ACModel/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************

# PUMA root
PUMA    ?= ../../Puma

# default target
TARGET  ?= linux-release

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

# libxml2 settings
XML2CONF ?= xml2-config
LIBXML2_INC := `$(XML2CONF) --cflags` 

CPPFLAGS += -I$(PUMA)/extern $(LIBXML2_INC)

# quick hack: filter-out no-rtti
CXXFLAGS := $(filter-out -fno-rtti, $(CXXFLAGS))

# ******************************
# *          I N F O S         *
# ******************************

$(info ---)
$(info Making ACModel library for TARGET=$(TARGET))
$(info   Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS))
$(info ---)
  
# ******************************
# *       S O U R C E S        *
# ******************************

# library file
LIBDIR := lib/$(TARGET)
LIB := $(LIBDIR)/libacmodel.a

CCSOURCES := $(wildcard *.cc) 

OBJECTDIR := ObjFiles/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:.cc=.o))

DEPDIR := DepFiles/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:.cc=.d))

DIRS := $(OBJECTDIR) $(DEPDIR) $(LIBDIR)

# ******************************
# *      T A R G E T S         *
# ******************************

all: $(LIB)

clean:
	@echo Making it clean.
	@rm -rf core core.* *~ lib DepFiles ObjFiles

# ******************************
# *       R U L E S            *
# ******************************

$(LIB): $(OBJECTS) 
	@echo "Creating library $@."
	@mkdir -p $(LIBDIR)
	@$(AR) rcs $@  $(OBJECTS)

$(OBJECTDIR)/%.o : %.cc 
	@echo Making dependency file $@.
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM -MP -MT $(OBJECTDIR)/$(<:%.cc=%.o) -MT $(DEPDIR)/$(<:%.cc=%.d) $< > $(DEPDIR)/$(<:%.cc=%.d)
	@echo Making object file $@.
	@mkdir -p $(OBJECTDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

.phony: all clean dirs showtarget

=== AspectC++/config/Makefile ===
#
# makefile for generating a config file for the installed Clang version
#

# PUMA root
PUMA    ?= ../../Puma

# default target
TARGET  ?= linux-release

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

# ******************************
# *       S E T T I N G S      *
# ******************************

# check whether llvm-config is available
ifeq ($(shell which $(LLVMCONF)),)
  $(error LLVMCONF ($(LLVMCONF)) is not found)
endif

LLVM_VERSION := $(shell $(LLVMCONF) --version)

LLVM_LIBDIR  := $(shell $(LLVMCONF) --libdir)
ifeq ($(_TARGET),win_x86_64) # handle '\' in path name
  LLVM_LIBDIR := $(subst \,/,$(LLVM_LIBDIR))
endif
LLVM_LIBS :=  $(LLVM_LIBDIR)/libclang*.a
# These functions need to be wrapped:
#   Parameters are omitted to be more version independent
LLVM_KEYS := _ZN5clang4Sema19canSkipFunctionBody \
             _ZN5clang4Sema21ProcessStmtAttributes

ifeq ($(_TARGET),macosx_x86_64) # on macOS the symbols have an additional '_'
  LLVM_KEYS := $(patsubst %, _%, $(LLVM_KEYS))
endif

# command to generate LLVM_SYMBOLS (a recursive variable!)
LLVM_SYMBOLS_GEN = $(foreach LLVM_LIB, $(LLVM_LIBS), $(foreach LLVM_KEY, $(LLVM_KEYS), $(filter _%, $(shell nm --defined-only $(LLVM_LIB) | grep "T $(LLVM_KEY)"))))

ifeq ($(_TARGET),macosx_x86_64) # on macOS the symbols have an additional '_'
  LLVM_SYMBOLS_GEN := $(patsubst _%, %, $(LLVM_SYMBOLS_GEN))
endif

# ******************************
# *       R U L E S            *
# ******************************

clang: clang-$(LLVM_VERSION).mk

# find the exact symbols using the keys in the clang libraries
clang-$(LLVM_VERSION).mk:
	@echo Generating config file for Clang $(LLVM_VERSION)
	@echo LLVM_SYMBOLS := $(LLVM_SYMBOLS_GEN) > $@

=== AspectC++/tests/Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 	  Bug549 Bug552 Bug554 DefaultArgs Bug561 Bug564 Bug566 Bug570 \
 	  Bug571-1 Bug571-2 Bug571-3 Bug575 Bug577 Bug427 AttribAligned \
           VirtualPointcuts Bug580 MacroExpansion Bug768 Bug769 Bug770 Bug772 \
-          Bug781 Bug784
+          Bug781 Bug784 BugUsingAttribute
 
 ifeq ($(FRONTEND),Clang)
 ACTESTS += DataFlowAnalysis
@@ -41,7 +41,7 @@
            ArrayAccessAdvice MatchScope GetBaseDerived \
            Bug-Typenames DefaultArgs2 CallViaADN Bug574 GetConditional Bug576 \
            Bug567 Bug568 Bug548 Bug589 Bug594 Bug598 CallRef Float128Basic \
-           EntityInfo VolatileResult
+           EntityInfo VolatileResult Bug792 BugAttribInConstexpr StdCxx17
 ACTESTS += Attribute_basic Attribute_inMacro Attribute_removeAttrs
 		   #Attribute_pointcuts Attribute_params Attribute_paramEvaluation \
 		   #Attribute_paramsIntrospection Attribute_stringParam

=== Puma/examples/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

SUBDIRS := $(shell find $(shell pwd) -maxdepth 1 -mindepth 1 -type d)
SUBDIRS := $(filter-out %/.svn %/CVS, $(SUBDIRS))
SUBDIRS := $(SUBDIRS)

#-------------------------------------------------
# rules
#-------------------------------------------------

all: $(SUBDIRS)
clean: $(SUBDIRS)

$(SUBDIRS):
	@$(MAKE) -C $@ $(MAKECMDGOALS)

.PHONY: all clean $(SUBDIRS)

=== Puma/src/Makefile ===
ifeq ($(MAKELEVEL),0)
$(error Sorry, this makefile is not intended to be \
used directly. Please use the makefile in the toplevel \
directory of the PUMA source tree instead)
endif

#-------------------------------------------------
# variables 
#-------------------------------------------------

AGXX    ?= $(subst ac++,ag++,$(AC))

include $(ROOT)/vars.mk

#-------------------------------------------------
# rules
#-------------------------------------------------

all: weave compile_after_weave

generate: config dirs
	@+$(MAKE) -f generate.mk

weave: generate
	@+$(MAKE) -f weave.mk

compile_after_weave: dirs weave
	@+$(MAKE) -f compile.mk

compile: dirs
	@+$(MAKE) -f compile.mk

dirs:
	@mkdir -p $(OBJDIR)
	@mkdir -p $(INCDIR)
	@mkdir -p $(STEP1)/src
	@mkdir -p $(STEP1)/dep
	@mkdir -p $(STEP1)/aspects/Puma
	@mkdir -p $(STEP1)/inc/Puma
	@mkdir -p $(STEP2)/src
	@mkdir -p $(STEP2)/dep
	@mkdir -p $(STEP2)/inc/Puma

config:
ifneq ($(ASPECTS),)
	@echo "Generating ac++ config file..."
	@mkdir -p $(dir $(CONFIG))
	@$(AGXX) --gen_config --c_compiler $(CXX) -o $(CONFIG)
	@perl -i -pe "s/^-I [\"]?\.[\"]?$$//g" $(CONFIG) 
endif

clean:
	@echo "Making sources clean..."
	@rm -rf $(GENDIR)

distclean: 
	@echo "Removing library, headers, and other generated files..."
	@rm -rf $(LIBDIR) $(INCDIR) $(ROOT)/gen-*

install:
	# nothing to do for install

dry:
	@+$(MAKE) -f weave.mk showinfo
	@+$(MAKE) -f compile.mk showinfo

#-------------------------------------------------
# targets
#-------------------------------------------------

.PHONY: all clean dirs generate weave compile dry install distclean config compile_after_weave

=== AspectC++/tests/ArrayAccessAdvice/Makefile ===
ACFLAGS += --builtin_operators --data_joinpoints
CXXFLAGS += -std=gnu++11
include ../Makefile.generic

=== AspectC++/tests/Instantiation/Makefile ===
ACFLAGS ?= -v9
include ../Makefile.generic

=== Puma/examples/annotator/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

PROG     := annotator
ROOT     := $(shell pwd)/../..
TARGET   ?= linux-release

OBJDIR   := obj
DEPDIR   := dep
GENDIR   := gen
INCDIR   := $(ROOT)/include $(ROOT)/extern $(GENDIR)
LIBDIR   := $(ROOT)/lib/$(TARGET)

ifeq ($(MAKELEVEL),0)

SOURCES  := $(wildcard *.ora) 
OBJECTS  := $(addprefix $(GENDIR)/,$(SOURCES:.ora=.ot))

else 

SOURCES  := $(wildcard *.cc) 
OBJECTS  := $(addprefix $(OBJDIR)/,$(SOURCES:.cc=.o))
DEPS     := $(addprefix $(DEPDIR)/,$(SOURCES:.cc=.d))

include $(ROOT)/vars.mk

CPPFLAGS += $(CXXFLAGS) $(addprefix -I,$(INCDIR))

endif

#-------------------------------------------------
# rules
#-------------------------------------------------

ifeq ($(MAKELEVEL),0)

all: $(OBJECTS)
	@$(MAKE)

else 

all: showinfo $(PROG)

showinfo:
	@echo 
	@echo "---"
	@echo "Compiling $(PROG) for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"
	@echo 

$(PROG): $(OBJECTS)
	@echo "Linking $@..."
	export LD_LIBRARY_PATH=$(LIBDIR); \
	$(CXX) -o $@ $^ -L$(LIBDIR) $(CXXFLAGS) -Wl,-Bstatic -lPuma -Wl,-Bdynamic $(CPPFLAGS) 
#	$(CXX) -o $@ $^ -L$(LIBDIR) $(CXXFLAGS) -Wl,-Bdynamic -lPuma -Wl,-Bdynamic $(CPPFLAGS) 

endif

clean:
	@echo "Making $(PROG) clean..."
	@rm -f $(PROG)
	@rm -rf $(DEPDIR) $(OBJDIR) $(GENDIR)

#-------------------------------------------------
# targets
#-------------------------------------------------

ifeq ($(MAKELEVEL),0)

$(GENDIR)/%.ot : %.ora
	@echo "Generating $@..."
	@mkdir -p $(GENDIR)
	@$(ROOT)/tools/orange/orange $< >>  $@

else 

$(OBJDIR)/%.o : %.cc
	@echo "Compiling $(filter %.cc,$^)..."
	@mkdir -p $(OBJDIR)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -g -o $@ $(filter %.cc,$^)

$(DEPDIR)/%.d : %.cc
	@echo "Generating dependencies for $(filter %.cc,$^)..."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM $(filter %.cc,$^) | \
	sed -e "s/$*\.o/$(OBJDIR)\/& $(DEPDIR)\/$*.d/g" > $@

endif

.PHONY: clean

#-------------------------------------------------
# includes
#-------------------------------------------------

ifneq ($(MAKELEVEL),0)
ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif
endif

=== Puma/src/win32/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

SUBDIRS := $(shell find $(shell pwd) -type d -maxdepth 1 -mindepth 1)
SUBDIRS := $(filter-out %/.svn, $(SUBDIRS))
SUBDIRS := $(SUBDIRS)

#-------------------------------------------------
# rules
#-------------------------------------------------

all: $(SUBDIRS)
clean: $(SUBDIRS)

$(SUBDIRS):
	@$(MAKE) -C $@ $(MAKECMDGOALS)

.PHONY: all clean $(SUBDIRS)

=== debian/changelog ===
aspectc++ (1:2.3+git20221129-1) unstable; urgency=medium

  * New upstream version
  * Build against llvm-14, closes: #1012184, #1004884, #1012897

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 29 Nov 2022 17:54:11 -0500

aspectc++ (1:2.3+git20211104-2) unstable; urgency=medium

  * Update float128.patch, kudost oFrédéric Bonnard <frediz@debian.org>
    for the patch!

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 22 Nov 2021 15:49:20 -0500

aspectc++ (1:2.3+git20211104-1) unstable; urgency=medium

  * New upstream version
  * Compile against clang-12, Closes: #997111

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 04 Nov 2021 11:30:14 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Reinhard Tartler <siretart@tauware.de>
-Build-Depends: debhelper (>= 10), pkg-config, libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-11-dev, libclang-11-dev
+Build-Depends: debhelper (>= 10), pkg-config, libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-14-dev, libclang-14-dev
 Build-Depends-Indep: doxygen, graphviz, gsfonts
 Standards-Version: 4.4.1
 Homepage: http://www.aspectc.org
